
#include "writer.h"
#include "maf.h"
#include <string.h>

#define XS 320
#define XFULL 384
#define YS 200
#define HEI 24
#define MAXNUM 26

#define XS2 196
#define YS2 120

extern unsigned char lapinaa[],
                     marqtxt[],mantxt[],roztxt[];

static unsigned char puf[XFULL*HEI],puf2[XFULL*HEI];

void writer(unsigned char *dest,int num,int x,int y,int blur)
{
    int n,i,off=x+y*XS;
    unsigned tmp;

    if(blur<1)
        blur=1;
    if(num>=MAXNUM)
        return;

    if(blur>1)
    {
        for(n=0;n<HEI;n++)
        {
            memset(&puf[n*XFULL],0,32);
            memcpy(&puf[n*XFULL+32],&lapinaa[num*XS*HEI+n*XS],XS);
            memset(&puf[n*XFULL+XFULL-32],0,32);
        }
        horiz_maf(puf,puf2, 0,0, 0,0, XFULL,HEI, XFULL,HEI, blur);
    }
    else
    {
        for(n=0;n<HEI;n++)
        {
            memset(&puf2[n*XFULL],0,32);
            memcpy(&puf2[n*XFULL+32],&lapinaa[num*XS*HEI+n*XS],XS);
            memset(&puf2[n*XFULL+XFULL-32],0,32);
        }
    }
    
    for(n=0;n<HEI;n++)
    {
        if(n+y<0 || n+y>=YS)
            continue;
        for(i=0;i<XS;i++)
            if(puf2[n*XFULL+i])
            {
                tmp=dest[off+n*XS+i]+puf2[n*XFULL+i];
                if(tmp>255)
                    tmp=255;
                dest[off+n*XS+i]=tmp;
            }
        //memcpy(&dest[off+n*XS],&puf2[n*XFULL],XS);
    }
}

void writer2(unsigned char *dest,int num,int x,int y)
{
    int n,i,off=x+XS*y,tmp;
    unsigned char *uva;

    switch(num)
    {
        case 0: uva=marqtxt; break;
        case 1: uva=mantxt; break;
        case 2: uva=roztxt; break;
    }

    for(n=0;n<YS2;n++)
        for(i=0;i<XS2;i++)
            if(uva[n*XS2+i])
            {
                tmp=dest[off+n*XS+i]+uva[n*XS2+i];
                if(tmp>255)
                    tmp=255;
                dest[off+n*XS+i]=tmp;
            }
}
